# coding: utf-8

"""
    D&D 5e API

    # Introduction  Welcome to the dnd5eapi, the Dungeons & Dragons 5th Edition API! This documentation should help you familiarize yourself with the resources available and how to consume them with HTTP requests. Read through the getting started section before you dive in. Most of your problems should be solved just by reading through it.  ## Getting Started  Let's make our first API request to the D&D 5th Edition API!  Open up a terminal and use [curl](http://curl.haxx.se/) or [httpie](http://httpie.org/) to make an API request for a resource. You can also scroll through the definitions below and send requests directly from the endpoint documentation!  For example, if you paste and run this `curl` command: ```bash curl -X GET \"https://www.dnd5eapi.co/api/ability-scores/cha\" -H \"Accept: application/json\" ```  We should see a result containing details about the Charisma ability score: ```bash {   \"index\": \"cha\",   \"name\": \"CHA\",   \"full_name\": \"Charisma\",   \"desc\": [     \"Charisma measures your ability to interact effectively with others. It       includes such factors as confidence and eloquence, and it can represent       a charming or commanding personality.\",     \"A Charisma check might arise when you try to influence or entertain       others, when you try to make an impression or tell a convincing lie,       or when you are navigating a tricky social situation. The Deception,       Intimidation, Performance, and Persuasion skills reflect aptitude in       certain kinds of Charisma checks.\"   ],   \"skills\": [     {       \"name\": \"Deception\",       \"index\": \"deception\",       \"url\": \"/api/skills/deception\"     },     {       \"name\": \"Intimidation\",       \"index\": \"intimidation\",       \"url\": \"/api/skills/intimidation\"     },     {       \"name\": \"Performance\",       \"index\": \"performance\",       \"url\": \"/api/skills/performance\"     },     {       \"name\": \"Persuasion\",       \"index\": \"persuasion\",       \"url\": \"/api/skills/persuasion\"     }   ],   \"url\": \"/api/ability-scores/cha\" } ```  ## Authentication  The dnd5eapi is a completely open API. No authentication is required to query and get data. This also means that we've limited what you can do to just `GET`-ing the data. If you find a mistake in the data, feel free to [message us](https://discord.gg/TQuYTv7).  ## GraphQL  This API supports [GraphQL](https://graphql.org/). The GraphQL URL for this API is `https://www.dnd5eapi.co/graphql`. Most of your questions regarding the GraphQL schema can be answered by querying the endpoint with the Apollo sandbox explorer.  ## Schemas  Definitions of all schemas will be accessible in a future update. Two of the most common schemas are described here.  ### `APIReference` Represents a minimal representation of a resource. The detailed representation of the referenced resource can be retrieved by making a request to the referenced `URL`. ``` APIReference {   index     string   name      string   url       string } ``` <hr>  ### `DC` Represents a difficulty check. ``` DC {   dc_type       APIReference   dc_value      number   success_type  \"none\" | \"half\" | \"other\" } ``` <hr>  ### `Damage` Represents damage. ``` Damage {   damage_type     APIReference   damage_dice     string } ``` <hr>  ### `Choice` Represents a choice made by a player. Commonly seen related to decisions made during character creation or combat (e.g.: the description of the cleric class, under **Proficiencies**, states \"Skills: Choose two from History, Insight, Medicine, Persuasion, and Religion\" [[SRD p15]](https://media.wizards.com/2016/downloads/DND/SRD-OGL_V5.1.pdf#page=15)) ``` Choice {   desc      string   choose    number   type      string   from      OptionSet } ``` <hr>  ### `OptionSet` The OptionSet structure provides the options to be chosen from, or sufficient data to fetch and interpret the options. All OptionSets have an `option_set_type` attribute that indicates the structure of the object that contains the options. The possible values are `options_array`, `equipment_category`, and `reference_list`. Other attributes on the OptionSet depend on the value of this attribute. - `options_array`   - `options` (array): An array of Option objects. Each item in the array represents an option that can be chosen. - `equipment_category`   - `equipment_category` (APIReference): A reference to an EquipmentCategory. Each item in the EquipmentCategory's `equipment` array represents one option that can be chosen. - `resource_list`   - `resource_list_url` (string): A reference (by URL) to a collection in the database. The URL may include query parameters. Each item in the resulting ResourceList's `results` array represents one option that can be chosen. <hr>  ### `Option` When the options are given in an `options_array`, each item in the array inherits from the Option structure. All Options have an `option_type` attribute that indicates the structure of the option. The value of this attribute indicates how the option should be handled, and each type has different attributes. The possible values and their corresponding attributes are listed below. - `reference` - A terminal option. Contains a reference to a Document that can be added to the list of options chosen.   - `item` (APIReference): A reference to the chosen item. - `action` - A terminal option. Contains information describing an action, for use within Multiattack actions.   - `action_name` (string): The name of the action, according to its `name` attribute.   - `count` (number | string): The number of times this action can be repeated if this option is chosen.   - `type` (string = `\"melee\" | \"ranged\" | \"ability\" | \"magic\"`, optional): For attack actions that can be either melee, ranged, abilities, or magic. - `multiple` - When this option is chosen, all of its child options are chosen, and must be resolved the same way as a normal option.   - `items` (array): An array of Option objects. All of them must be taken if the option is chosen. - `choice` - A nested choice. If this option is chosen, the Choice structure contained within must be resolved like a normal Choice structure, and the results are the chosen options.   - `choice` (Choice): The Choice to resolve. - `string` - A terminal option. Contains a reference to a string.   - `string` (string): The string. - `ideal` - A terminal option. Contains information about an ideal.   - `desc` (string): A description of the ideal.   - `alignments` (ApiReference[]): A list of alignments of those who might follow the ideal. - `counted_reference` - A terminal option. Contains a reference to something else in the API along with a count.   - `count` (number): Count.   - `of` (ApiReference): Thing being referenced. - `score_prerequisite` - A terminal option. Contains a reference to an ability score and a minimum score.   - `ability_score` (ApiReference): Ability score being referenced.   - `minimum_score` (number): The minimum score required to satisfy the prerequisite. - `ability_bonus` - A terminal option. Contains a reference to an ability score and a bonus   - `ability_score` (ApiReference): Ability score being referenced   - `bonus` (number): The bonus being applied to the ability score - `breath` - A terminal option: Contains a reference to information about a breath attack.   - `name` (string): Name of the breath.   - `dc` (DC): Difficulty check of the breath attack.   - `damage` ([Damage]): Damage dealt by the breath attack, if any. - `damage` - A terminal option. Contains information about damage.   - `damage_type` (ApiReference): Reference to type of damage.   - `damage_dice` (string): Damage expressed in dice (e.g. \"13d6\").   - `notes` (string): Information regarding the damage.  ## FAQ  ### What is the SRD? The SRD, or Systems Reference Document, contains guidelines for publishing content under the OGL. This allows for some of the data for D&D 5e to be open source. The API only covers data that can be found in the SRD. [Here's a link to the full text of the SRD.](https://media.wizards.com/2016/downloads/DND/SRD-OGL_V5.1.pdf)  ### What is the OGL? The Open Game License (OGL) is a public copyright license by Wizards of the Coast that may be used by tabletop role-playing game developers to grant permission to modify, copy, and redistribute some of the content designed for their games, notably game mechanics. However, they must share-alike copies and derivative works. [More information about the OGL can be found here.](https://en.wikipedia.org/wiki/Open_Game_License)  ### A monster, spell, subclass, etc. is missing from the API / Database. Can I add it? Please check if the data is within the SRD. If it is, feel free to open an issue or PR to add it yourself. Otherwise, due to legal reasons, we cannot add it.  ### Can this API be self hosted? Yes it can! You can also host the data yourself if you don't want to use the API at all. You can also make changes and add extra data if you like. However, it is up to you to merge in new changes to the data and API.  #### Can I publish is on <insert platform>? Is this free use? Yes, you can. The API itself is under the [MIT license](https://opensource.org/licenses/MIT), and the underlying data accessible via the API is supported under the SRD and OGL.  # Status Page  The status page for the API can be found here: https://5e-bits.github.io/dnd-uptime/  # Chat  Come hang out with us [on Discord](https://discord.gg/TQuYTv7)!  # Contribute  This API is built from two repositories.   - The repo containing the data lives here: https://github.com/bagelbits/5e-database   - The repo with the API implementation lives here: https://github.com/bagelbits/5e-srd-api  This is a evolving API and having fresh ideas are always welcome! You can open an issue in either repo, open a PR for changes, or just discuss with other users in this discord.   # noqa: E501

    OpenAPI spec version: 0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from dnd5apy.models.api_reference import APIReference  # noqa: F401,E501

class Monster(APIReference):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'desc': 'list[str]',
        'charisma': 'float',
        'constitution': 'float',
        'dexterity': 'float',
        'intelligence': 'float',
        'strength': 'float',
        'wisdom': 'float',
        'image': 'str',
        'size': 'str',
        'type': 'str',
        'subtype': 'str',
        'alignments': 'str',
        'armor_class': 'list[MonsterArmorClass]',
        'hit_points': 'float',
        'hit_dice': 'str',
        'hit_points_roll': 'str',
        'actions': 'list[MonsterAction]',
        'legendary_actions': 'list[MonsterAction]',
        'challenge_rating': 'float',
        'condition_immunities': 'list[APIReference]',
        'damage_immunities': 'list[str]',
        'damage_resistances': 'list[str]',
        'damage_vulnerabilities': 'list[str]',
        'forms': 'list[APIReference]',
        'languages': 'str',
        'proficiencies': 'list[MonsterProficiency]',
        'reactions': 'list[MonsterAction]',
        'senses': 'object',
        'special_abilities': 'list[MonsterSpecialAbility]',
        'speed': 'MonsterSpeed',
        'xp': 'float'
    }
    if hasattr(APIReference, "swagger_types"):
        swagger_types.update(APIReference.swagger_types)

    attribute_map = {
        'desc': 'desc',
        'charisma': 'charisma',
        'constitution': 'constitution',
        'dexterity': 'dexterity',
        'intelligence': 'intelligence',
        'strength': 'strength',
        'wisdom': 'wisdom',
        'image': 'image',
        'size': 'size',
        'type': 'type',
        'subtype': 'subtype',
        'alignments': 'alignments',
        'armor_class': 'armor_class',
        'hit_points': 'hit_points',
        'hit_dice': 'hit_dice',
        'hit_points_roll': 'hit_points_roll',
        'actions': 'actions',
        'legendary_actions': 'legendary_actions',
        'challenge_rating': 'challenge_rating',
        'condition_immunities': 'condition_immunities',
        'damage_immunities': 'damage_immunities',
        'damage_resistances': 'damage_resistances',
        'damage_vulnerabilities': 'damage_vulnerabilities',
        'forms': 'forms',
        'languages': 'languages',
        'proficiencies': 'proficiencies',
        'reactions': 'reactions',
        'senses': 'senses',
        'special_abilities': 'special_abilities',
        'speed': 'speed',
        'xp': 'xp'
    }
    if hasattr(APIReference, "attribute_map"):
        attribute_map.update(APIReference.attribute_map)

    def __init__(self, desc=None, charisma=None, constitution=None, dexterity=None, intelligence=None, strength=None, wisdom=None, image=None, size=None, type=None, subtype=None, alignments=None, armor_class=None, hit_points=None, hit_dice=None, hit_points_roll=None, actions=None, legendary_actions=None, challenge_rating=None, condition_immunities=None, damage_immunities=None, damage_resistances=None, damage_vulnerabilities=None, forms=None, languages=None, proficiencies=None, reactions=None, senses=None, special_abilities=None, speed=None, xp=None, *args, **kwargs):  # noqa: E501
        """Monster - a model defined in Swagger"""  # noqa: E501
        self._desc = None
        self._charisma = None
        self._constitution = None
        self._dexterity = None
        self._intelligence = None
        self._strength = None
        self._wisdom = None
        self._image = None
        self._size = None
        self._type = None
        self._subtype = None
        self._alignments = None
        self._armor_class = None
        self._hit_points = None
        self._hit_dice = None
        self._hit_points_roll = None
        self._actions = None
        self._legendary_actions = None
        self._challenge_rating = None
        self._condition_immunities = None
        self._damage_immunities = None
        self._damage_resistances = None
        self._damage_vulnerabilities = None
        self._forms = None
        self._languages = None
        self._proficiencies = None
        self._reactions = None
        self._senses = None
        self._special_abilities = None
        self._speed = None
        self._xp = None
        self.discriminator = None
        if desc is not None:
            self.desc = desc
        if charisma is not None:
            self.charisma = charisma
        if constitution is not None:
            self.constitution = constitution
        if dexterity is not None:
            self.dexterity = dexterity
        if intelligence is not None:
            self.intelligence = intelligence
        if strength is not None:
            self.strength = strength
        if wisdom is not None:
            self.wisdom = wisdom
        if image is not None:
            self.image = image
        if size is not None:
            self.size = size
        if type is not None:
            self.type = type
        if subtype is not None:
            self.subtype = subtype
        if alignments is not None:
            self.alignments = alignments
        if armor_class is not None:
            self.armor_class = armor_class
        if hit_points is not None:
            self.hit_points = hit_points
        if hit_dice is not None:
            self.hit_dice = hit_dice
        if hit_points_roll is not None:
            self.hit_points_roll = hit_points_roll
        if actions is not None:
            self.actions = actions
        if legendary_actions is not None:
            self.legendary_actions = legendary_actions
        if challenge_rating is not None:
            self.challenge_rating = challenge_rating
        if condition_immunities is not None:
            self.condition_immunities = condition_immunities
        if damage_immunities is not None:
            self.damage_immunities = damage_immunities
        if damage_resistances is not None:
            self.damage_resistances = damage_resistances
        if damage_vulnerabilities is not None:
            self.damage_vulnerabilities = damage_vulnerabilities
        if forms is not None:
            self.forms = forms
        if languages is not None:
            self.languages = languages
        if proficiencies is not None:
            self.proficiencies = proficiencies
        if reactions is not None:
            self.reactions = reactions
        if senses is not None:
            self.senses = senses
        if special_abilities is not None:
            self.special_abilities = special_abilities
        if speed is not None:
            self.speed = speed
        if xp is not None:
            self.xp = xp
        APIReference.__init__(self, *args, **kwargs)

    @property
    def desc(self):
        """Gets the desc of this Monster.  # noqa: E501

        Description of the resource.  # noqa: E501

        :return: The desc of this Monster.  # noqa: E501
        :rtype: list[str]
        """
        return self._desc

    @desc.setter
    def desc(self, desc):
        """Sets the desc of this Monster.

        Description of the resource.  # noqa: E501

        :param desc: The desc of this Monster.  # noqa: E501
        :type: list[str]
        """

        self._desc = desc

    @property
    def charisma(self):
        """Gets the charisma of this Monster.  # noqa: E501

        A monster's ability to charm or intimidate a player.  # noqa: E501

        :return: The charisma of this Monster.  # noqa: E501
        :rtype: float
        """
        return self._charisma

    @charisma.setter
    def charisma(self, charisma):
        """Sets the charisma of this Monster.

        A monster's ability to charm or intimidate a player.  # noqa: E501

        :param charisma: The charisma of this Monster.  # noqa: E501
        :type: float
        """

        self._charisma = charisma

    @property
    def constitution(self):
        """Gets the constitution of this Monster.  # noqa: E501

        How sturdy a monster is.\"  # noqa: E501

        :return: The constitution of this Monster.  # noqa: E501
        :rtype: float
        """
        return self._constitution

    @constitution.setter
    def constitution(self, constitution):
        """Sets the constitution of this Monster.

        How sturdy a monster is.\"  # noqa: E501

        :param constitution: The constitution of this Monster.  # noqa: E501
        :type: float
        """

        self._constitution = constitution

    @property
    def dexterity(self):
        """Gets the dexterity of this Monster.  # noqa: E501

        The monster's ability for swift movement or stealth  # noqa: E501

        :return: The dexterity of this Monster.  # noqa: E501
        :rtype: float
        """
        return self._dexterity

    @dexterity.setter
    def dexterity(self, dexterity):
        """Sets the dexterity of this Monster.

        The monster's ability for swift movement or stealth  # noqa: E501

        :param dexterity: The dexterity of this Monster.  # noqa: E501
        :type: float
        """

        self._dexterity = dexterity

    @property
    def intelligence(self):
        """Gets the intelligence of this Monster.  # noqa: E501

        The monster's ability to outsmart a player.  # noqa: E501

        :return: The intelligence of this Monster.  # noqa: E501
        :rtype: float
        """
        return self._intelligence

    @intelligence.setter
    def intelligence(self, intelligence):
        """Sets the intelligence of this Monster.

        The monster's ability to outsmart a player.  # noqa: E501

        :param intelligence: The intelligence of this Monster.  # noqa: E501
        :type: float
        """

        self._intelligence = intelligence

    @property
    def strength(self):
        """Gets the strength of this Monster.  # noqa: E501

        How hard a monster can hit a player.  # noqa: E501

        :return: The strength of this Monster.  # noqa: E501
        :rtype: float
        """
        return self._strength

    @strength.setter
    def strength(self, strength):
        """Sets the strength of this Monster.

        How hard a monster can hit a player.  # noqa: E501

        :param strength: The strength of this Monster.  # noqa: E501
        :type: float
        """

        self._strength = strength

    @property
    def wisdom(self):
        """Gets the wisdom of this Monster.  # noqa: E501

        A monster's ability to ascertain the player's plan.  # noqa: E501

        :return: The wisdom of this Monster.  # noqa: E501
        :rtype: float
        """
        return self._wisdom

    @wisdom.setter
    def wisdom(self, wisdom):
        """Sets the wisdom of this Monster.

        A monster's ability to ascertain the player's plan.  # noqa: E501

        :param wisdom: The wisdom of this Monster.  # noqa: E501
        :type: float
        """

        self._wisdom = wisdom

    @property
    def image(self):
        """Gets the image of this Monster.  # noqa: E501

        The image url of the monster.  # noqa: E501

        :return: The image of this Monster.  # noqa: E501
        :rtype: str
        """
        return self._image

    @image.setter
    def image(self, image):
        """Sets the image of this Monster.

        The image url of the monster.  # noqa: E501

        :param image: The image of this Monster.  # noqa: E501
        :type: str
        """

        self._image = image

    @property
    def size(self):
        """Gets the size of this Monster.  # noqa: E501

        The size of the monster ranging from Tiny to Gargantuan.\"  # noqa: E501

        :return: The size of this Monster.  # noqa: E501
        :rtype: str
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this Monster.

        The size of the monster ranging from Tiny to Gargantuan.\"  # noqa: E501

        :param size: The size of this Monster.  # noqa: E501
        :type: str
        """
        allowed_values = ["Tiny", "Small", "Medium", "Large", "Huge", "Gargantuan"]  # noqa: E501
        if size not in allowed_values:
            raise ValueError(
                "Invalid value for `size` ({0}), must be one of {1}"  # noqa: E501
                .format(size, allowed_values)
            )

        self._size = size

    @property
    def type(self):
        """Gets the type of this Monster.  # noqa: E501

        The type of monster.  # noqa: E501

        :return: The type of this Monster.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Monster.

        The type of monster.  # noqa: E501

        :param type: The type of this Monster.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def subtype(self):
        """Gets the subtype of this Monster.  # noqa: E501

        The sub-category of a monster used for classification of monsters.\"  # noqa: E501

        :return: The subtype of this Monster.  # noqa: E501
        :rtype: str
        """
        return self._subtype

    @subtype.setter
    def subtype(self, subtype):
        """Sets the subtype of this Monster.

        The sub-category of a monster used for classification of monsters.\"  # noqa: E501

        :param subtype: The subtype of this Monster.  # noqa: E501
        :type: str
        """

        self._subtype = subtype

    @property
    def alignments(self):
        """Gets the alignments of this Monster.  # noqa: E501

        A creature's general moral and personal attitudes.  # noqa: E501

        :return: The alignments of this Monster.  # noqa: E501
        :rtype: str
        """
        return self._alignments

    @alignments.setter
    def alignments(self, alignments):
        """Sets the alignments of this Monster.

        A creature's general moral and personal attitudes.  # noqa: E501

        :param alignments: The alignments of this Monster.  # noqa: E501
        :type: str
        """
        allowed_values = ["chaotic neutral", "chaotic evil", "chaotic good", "lawful neutral", "lawful evil", "lawful good", "neutral", "neutral evil", "neutral good", "any alignment", "unaligned"]  # noqa: E501
        if alignments not in allowed_values:
            raise ValueError(
                "Invalid value for `alignments` ({0}), must be one of {1}"  # noqa: E501
                .format(alignments, allowed_values)
            )

        self._alignments = alignments

    @property
    def armor_class(self):
        """Gets the armor_class of this Monster.  # noqa: E501

        The difficulty for a player to successfully deal damage to a monster.  # noqa: E501

        :return: The armor_class of this Monster.  # noqa: E501
        :rtype: list[MonsterArmorClass]
        """
        return self._armor_class

    @armor_class.setter
    def armor_class(self, armor_class):
        """Sets the armor_class of this Monster.

        The difficulty for a player to successfully deal damage to a monster.  # noqa: E501

        :param armor_class: The armor_class of this Monster.  # noqa: E501
        :type: list[MonsterArmorClass]
        """

        self._armor_class = armor_class

    @property
    def hit_points(self):
        """Gets the hit_points of this Monster.  # noqa: E501

        The hit points of a monster determine how much damage it is able to take before it can be defeated.  # noqa: E501

        :return: The hit_points of this Monster.  # noqa: E501
        :rtype: float
        """
        return self._hit_points

    @hit_points.setter
    def hit_points(self, hit_points):
        """Sets the hit_points of this Monster.

        The hit points of a monster determine how much damage it is able to take before it can be defeated.  # noqa: E501

        :param hit_points: The hit_points of this Monster.  # noqa: E501
        :type: float
        """

        self._hit_points = hit_points

    @property
    def hit_dice(self):
        """Gets the hit_dice of this Monster.  # noqa: E501

        The hit die of a monster can be used to make a version of the same monster whose hit points are determined by the roll of the die. For example: A monster with 2d6 would have its hit points determine by rolling a 6 sided die twice.  # noqa: E501

        :return: The hit_dice of this Monster.  # noqa: E501
        :rtype: str
        """
        return self._hit_dice

    @hit_dice.setter
    def hit_dice(self, hit_dice):
        """Sets the hit_dice of this Monster.

        The hit die of a monster can be used to make a version of the same monster whose hit points are determined by the roll of the die. For example: A monster with 2d6 would have its hit points determine by rolling a 6 sided die twice.  # noqa: E501

        :param hit_dice: The hit_dice of this Monster.  # noqa: E501
        :type: str
        """

        self._hit_dice = hit_dice

    @property
    def hit_points_roll(self):
        """Gets the hit_points_roll of this Monster.  # noqa: E501

        The roll for determining a monster's hit points, which consists of the hit dice (e.g. 18d10) and the modifier determined by its Constitution (e.g. +36). For example, 18d10+36  # noqa: E501

        :return: The hit_points_roll of this Monster.  # noqa: E501
        :rtype: str
        """
        return self._hit_points_roll

    @hit_points_roll.setter
    def hit_points_roll(self, hit_points_roll):
        """Sets the hit_points_roll of this Monster.

        The roll for determining a monster's hit points, which consists of the hit dice (e.g. 18d10) and the modifier determined by its Constitution (e.g. +36). For example, 18d10+36  # noqa: E501

        :param hit_points_roll: The hit_points_roll of this Monster.  # noqa: E501
        :type: str
        """

        self._hit_points_roll = hit_points_roll

    @property
    def actions(self):
        """Gets the actions of this Monster.  # noqa: E501

        A list of actions that are available to the monster to take during combat.  # noqa: E501

        :return: The actions of this Monster.  # noqa: E501
        :rtype: list[MonsterAction]
        """
        return self._actions

    @actions.setter
    def actions(self, actions):
        """Sets the actions of this Monster.

        A list of actions that are available to the monster to take during combat.  # noqa: E501

        :param actions: The actions of this Monster.  # noqa: E501
        :type: list[MonsterAction]
        """

        self._actions = actions

    @property
    def legendary_actions(self):
        """Gets the legendary_actions of this Monster.  # noqa: E501

        A list of legendary actions that are available to the monster to take during combat.  # noqa: E501

        :return: The legendary_actions of this Monster.  # noqa: E501
        :rtype: list[MonsterAction]
        """
        return self._legendary_actions

    @legendary_actions.setter
    def legendary_actions(self, legendary_actions):
        """Sets the legendary_actions of this Monster.

        A list of legendary actions that are available to the monster to take during combat.  # noqa: E501

        :param legendary_actions: The legendary_actions of this Monster.  # noqa: E501
        :type: list[MonsterAction]
        """

        self._legendary_actions = legendary_actions

    @property
    def challenge_rating(self):
        """Gets the challenge_rating of this Monster.  # noqa: E501

        A monster's challenge rating is a guideline number that says when a monster becomes an appropriate challenge against the party's average level. For example. A group of 4 players with an average level of 4 would have an appropriate combat challenge against a monster with a challenge rating of 4 but a monster with a challenge rating of 8 against the same group of players would pose a significant threat.  # noqa: E501

        :return: The challenge_rating of this Monster.  # noqa: E501
        :rtype: float
        """
        return self._challenge_rating

    @challenge_rating.setter
    def challenge_rating(self, challenge_rating):
        """Sets the challenge_rating of this Monster.

        A monster's challenge rating is a guideline number that says when a monster becomes an appropriate challenge against the party's average level. For example. A group of 4 players with an average level of 4 would have an appropriate combat challenge against a monster with a challenge rating of 4 but a monster with a challenge rating of 8 against the same group of players would pose a significant threat.  # noqa: E501

        :param challenge_rating: The challenge_rating of this Monster.  # noqa: E501
        :type: float
        """

        self._challenge_rating = challenge_rating

    @property
    def condition_immunities(self):
        """Gets the condition_immunities of this Monster.  # noqa: E501

        A list of conditions that a monster is immune to.  # noqa: E501

        :return: The condition_immunities of this Monster.  # noqa: E501
        :rtype: list[APIReference]
        """
        return self._condition_immunities

    @condition_immunities.setter
    def condition_immunities(self, condition_immunities):
        """Sets the condition_immunities of this Monster.

        A list of conditions that a monster is immune to.  # noqa: E501

        :param condition_immunities: The condition_immunities of this Monster.  # noqa: E501
        :type: list[APIReference]
        """

        self._condition_immunities = condition_immunities

    @property
    def damage_immunities(self):
        """Gets the damage_immunities of this Monster.  # noqa: E501

        A list of damage types that a monster will take double damage from.  # noqa: E501

        :return: The damage_immunities of this Monster.  # noqa: E501
        :rtype: list[str]
        """
        return self._damage_immunities

    @damage_immunities.setter
    def damage_immunities(self, damage_immunities):
        """Sets the damage_immunities of this Monster.

        A list of damage types that a monster will take double damage from.  # noqa: E501

        :param damage_immunities: The damage_immunities of this Monster.  # noqa: E501
        :type: list[str]
        """

        self._damage_immunities = damage_immunities

    @property
    def damage_resistances(self):
        """Gets the damage_resistances of this Monster.  # noqa: E501

        A list of damage types that a monster will take half damage from.  # noqa: E501

        :return: The damage_resistances of this Monster.  # noqa: E501
        :rtype: list[str]
        """
        return self._damage_resistances

    @damage_resistances.setter
    def damage_resistances(self, damage_resistances):
        """Sets the damage_resistances of this Monster.

        A list of damage types that a monster will take half damage from.  # noqa: E501

        :param damage_resistances: The damage_resistances of this Monster.  # noqa: E501
        :type: list[str]
        """

        self._damage_resistances = damage_resistances

    @property
    def damage_vulnerabilities(self):
        """Gets the damage_vulnerabilities of this Monster.  # noqa: E501

        A list of damage types that a monster will take double damage from.  # noqa: E501

        :return: The damage_vulnerabilities of this Monster.  # noqa: E501
        :rtype: list[str]
        """
        return self._damage_vulnerabilities

    @damage_vulnerabilities.setter
    def damage_vulnerabilities(self, damage_vulnerabilities):
        """Sets the damage_vulnerabilities of this Monster.

        A list of damage types that a monster will take double damage from.  # noqa: E501

        :param damage_vulnerabilities: The damage_vulnerabilities of this Monster.  # noqa: E501
        :type: list[str]
        """

        self._damage_vulnerabilities = damage_vulnerabilities

    @property
    def forms(self):
        """Gets the forms of this Monster.  # noqa: E501

        List of other related monster entries that are of the same form. Only applicable to Lycanthropes that have multiple forms.  # noqa: E501

        :return: The forms of this Monster.  # noqa: E501
        :rtype: list[APIReference]
        """
        return self._forms

    @forms.setter
    def forms(self, forms):
        """Sets the forms of this Monster.

        List of other related monster entries that are of the same form. Only applicable to Lycanthropes that have multiple forms.  # noqa: E501

        :param forms: The forms of this Monster.  # noqa: E501
        :type: list[APIReference]
        """

        self._forms = forms

    @property
    def languages(self):
        """Gets the languages of this Monster.  # noqa: E501

        The languages a monster is able to speak.  # noqa: E501

        :return: The languages of this Monster.  # noqa: E501
        :rtype: str
        """
        return self._languages

    @languages.setter
    def languages(self, languages):
        """Sets the languages of this Monster.

        The languages a monster is able to speak.  # noqa: E501

        :param languages: The languages of this Monster.  # noqa: E501
        :type: str
        """

        self._languages = languages

    @property
    def proficiencies(self):
        """Gets the proficiencies of this Monster.  # noqa: E501

        A list of proficiencies of a monster.  # noqa: E501

        :return: The proficiencies of this Monster.  # noqa: E501
        :rtype: list[MonsterProficiency]
        """
        return self._proficiencies

    @proficiencies.setter
    def proficiencies(self, proficiencies):
        """Sets the proficiencies of this Monster.

        A list of proficiencies of a monster.  # noqa: E501

        :param proficiencies: The proficiencies of this Monster.  # noqa: E501
        :type: list[MonsterProficiency]
        """

        self._proficiencies = proficiencies

    @property
    def reactions(self):
        """Gets the reactions of this Monster.  # noqa: E501

        A list of reactions that is available to the monster to take during combat.  # noqa: E501

        :return: The reactions of this Monster.  # noqa: E501
        :rtype: list[MonsterAction]
        """
        return self._reactions

    @reactions.setter
    def reactions(self, reactions):
        """Sets the reactions of this Monster.

        A list of reactions that is available to the monster to take during combat.  # noqa: E501

        :param reactions: The reactions of this Monster.  # noqa: E501
        :type: list[MonsterAction]
        """

        self._reactions = reactions

    @property
    def senses(self):
        """Gets the senses of this Monster.  # noqa: E501

        Monsters typically have a passive perception but they might also have other senses to detect players.  # noqa: E501

        :return: The senses of this Monster.  # noqa: E501
        :rtype: object
        """
        return self._senses

    @senses.setter
    def senses(self, senses):
        """Sets the senses of this Monster.

        Monsters typically have a passive perception but they might also have other senses to detect players.  # noqa: E501

        :param senses: The senses of this Monster.  # noqa: E501
        :type: object
        """

        self._senses = senses

    @property
    def special_abilities(self):
        """Gets the special_abilities of this Monster.  # noqa: E501

        A list of the monster's special abilities.  # noqa: E501

        :return: The special_abilities of this Monster.  # noqa: E501
        :rtype: list[MonsterSpecialAbility]
        """
        return self._special_abilities

    @special_abilities.setter
    def special_abilities(self, special_abilities):
        """Sets the special_abilities of this Monster.

        A list of the monster's special abilities.  # noqa: E501

        :param special_abilities: The special_abilities of this Monster.  # noqa: E501
        :type: list[MonsterSpecialAbility]
        """

        self._special_abilities = special_abilities

    @property
    def speed(self):
        """Gets the speed of this Monster.  # noqa: E501


        :return: The speed of this Monster.  # noqa: E501
        :rtype: MonsterSpeed
        """
        return self._speed

    @speed.setter
    def speed(self, speed):
        """Sets the speed of this Monster.


        :param speed: The speed of this Monster.  # noqa: E501
        :type: MonsterSpeed
        """

        self._speed = speed

    @property
    def xp(self):
        """Gets the xp of this Monster.  # noqa: E501

        The number of experience points (XP) a monster is worth is based on its challenge rating.  # noqa: E501

        :return: The xp of this Monster.  # noqa: E501
        :rtype: float
        """
        return self._xp

    @xp.setter
    def xp(self, xp):
        """Sets the xp of this Monster.

        The number of experience points (XP) a monster is worth is based on its challenge rating.  # noqa: E501

        :param xp: The xp of this Monster.  # noqa: E501
        :type: float
        """

        self._xp = xp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Monster, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Monster):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
