# coding: utf-8

"""
    D&D 5e API

    # Introduction  Welcome to the dnd5eapi, the Dungeons & Dragons 5th Edition API! This documentation should help you familiarize yourself with the resources available and how to consume them with HTTP requests. Read through the getting started section before you dive in. Most of your problems should be solved just by reading through it.  ## Getting Started  Let's make our first API request to the D&D 5th Edition API!  Open up a terminal and use [curl](http://curl.haxx.se/) or [httpie](http://httpie.org/) to make an API request for a resource. You can also scroll through the definitions below and send requests directly from the endpoint documentation!  For example, if you paste and run this `curl` command: ```bash curl -X GET \"https://www.dnd5eapi.co/api/ability-scores/cha\" -H \"Accept: application/json\" ```  We should see a result containing details about the Charisma ability score: ```bash {   \"index\": \"cha\",   \"name\": \"CHA\",   \"full_name\": \"Charisma\",   \"desc\": [     \"Charisma measures your ability to interact effectively with others. It       includes such factors as confidence and eloquence, and it can represent       a charming or commanding personality.\",     \"A Charisma check might arise when you try to influence or entertain       others, when you try to make an impression or tell a convincing lie,       or when you are navigating a tricky social situation. The Deception,       Intimidation, Performance, and Persuasion skills reflect aptitude in       certain kinds of Charisma checks.\"   ],   \"skills\": [     {       \"name\": \"Deception\",       \"index\": \"deception\",       \"url\": \"/api/skills/deception\"     },     {       \"name\": \"Intimidation\",       \"index\": \"intimidation\",       \"url\": \"/api/skills/intimidation\"     },     {       \"name\": \"Performance\",       \"index\": \"performance\",       \"url\": \"/api/skills/performance\"     },     {       \"name\": \"Persuasion\",       \"index\": \"persuasion\",       \"url\": \"/api/skills/persuasion\"     }   ],   \"url\": \"/api/ability-scores/cha\" } ```  ## Authentication  The dnd5eapi is a completely open API. No authentication is required to query and get data. This also means that we've limited what you can do to just `GET`-ing the data. If you find a mistake in the data, feel free to [message us](https://discord.gg/TQuYTv7).  ## GraphQL  This API supports [GraphQL](https://graphql.org/). The GraphQL URL for this API is `https://www.dnd5eapi.co/graphql`. Most of your questions regarding the GraphQL schema can be answered by querying the endpoint with the Apollo sandbox explorer.  ## Schemas  Definitions of all schemas will be accessible in a future update. Two of the most common schemas are described here.  ### `APIReference` Represents a minimal representation of a resource. The detailed representation of the referenced resource can be retrieved by making a request to the referenced `URL`. ``` APIReference {   index     string   name      string   url       string } ``` <hr>  ### `DC` Represents a difficulty check. ``` DC {   dc_type       APIReference   dc_value      number   success_type  \"none\" | \"half\" | \"other\" } ``` <hr>  ### `Damage` Represents damage. ``` Damage {   damage_type     APIReference   damage_dice     string } ``` <hr>  ### `Choice` Represents a choice made by a player. Commonly seen related to decisions made during character creation or combat (e.g.: the description of the cleric class, under **Proficiencies**, states \"Skills: Choose two from History, Insight, Medicine, Persuasion, and Religion\" [[SRD p15]](https://media.wizards.com/2016/downloads/DND/SRD-OGL_V5.1.pdf#page=15)) ``` Choice {   desc      string   choose    number   type      string   from      OptionSet } ``` <hr>  ### `OptionSet` The OptionSet structure provides the options to be chosen from, or sufficient data to fetch and interpret the options. All OptionSets have an `option_set_type` attribute that indicates the structure of the object that contains the options. The possible values are `options_array`, `equipment_category`, and `reference_list`. Other attributes on the OptionSet depend on the value of this attribute. - `options_array`   - `options` (array): An array of Option objects. Each item in the array represents an option that can be chosen. - `equipment_category`   - `equipment_category` (APIReference): A reference to an EquipmentCategory. Each item in the EquipmentCategory's `equipment` array represents one option that can be chosen. - `resource_list`   - `resource_list_url` (string): A reference (by URL) to a collection in the database. The URL may include query parameters. Each item in the resulting ResourceList's `results` array represents one option that can be chosen. <hr>  ### `Option` When the options are given in an `options_array`, each item in the array inherits from the Option structure. All Options have an `option_type` attribute that indicates the structure of the option. The value of this attribute indicates how the option should be handled, and each type has different attributes. The possible values and their corresponding attributes are listed below. - `reference` - A terminal option. Contains a reference to a Document that can be added to the list of options chosen.   - `item` (APIReference): A reference to the chosen item. - `action` - A terminal option. Contains information describing an action, for use within Multiattack actions.   - `action_name` (string): The name of the action, according to its `name` attribute.   - `count` (number | string): The number of times this action can be repeated if this option is chosen.   - `type` (string = `\"melee\" | \"ranged\" | \"ability\" | \"magic\"`, optional): For attack actions that can be either melee, ranged, abilities, or magic. - `multiple` - When this option is chosen, all of its child options are chosen, and must be resolved the same way as a normal option.   - `items` (array): An array of Option objects. All of them must be taken if the option is chosen. - `choice` - A nested choice. If this option is chosen, the Choice structure contained within must be resolved like a normal Choice structure, and the results are the chosen options.   - `choice` (Choice): The Choice to resolve. - `string` - A terminal option. Contains a reference to a string.   - `string` (string): The string. - `ideal` - A terminal option. Contains information about an ideal.   - `desc` (string): A description of the ideal.   - `alignments` (ApiReference[]): A list of alignments of those who might follow the ideal. - `counted_reference` - A terminal option. Contains a reference to something else in the API along with a count.   - `count` (number): Count.   - `of` (ApiReference): Thing being referenced. - `score_prerequisite` - A terminal option. Contains a reference to an ability score and a minimum score.   - `ability_score` (ApiReference): Ability score being referenced.   - `minimum_score` (number): The minimum score required to satisfy the prerequisite. - `ability_bonus` - A terminal option. Contains a reference to an ability score and a bonus   - `ability_score` (ApiReference): Ability score being referenced   - `bonus` (number): The bonus being applied to the ability score - `breath` - A terminal option: Contains a reference to information about a breath attack.   - `name` (string): Name of the breath.   - `dc` (DC): Difficulty check of the breath attack.   - `damage` ([Damage]): Damage dealt by the breath attack, if any. - `damage` - A terminal option. Contains information about damage.   - `damage_type` (ApiReference): Reference to type of damage.   - `damage_dice` (string): Damage expressed in dice (e.g. \"13d6\").   - `notes` (string): Information regarding the damage.  ## FAQ  ### What is the SRD? The SRD, or Systems Reference Document, contains guidelines for publishing content under the OGL. This allows for some of the data for D&D 5e to be open source. The API only covers data that can be found in the SRD. [Here's a link to the full text of the SRD.](https://media.wizards.com/2016/downloads/DND/SRD-OGL_V5.1.pdf)  ### What is the OGL? The Open Game License (OGL) is a public copyright license by Wizards of the Coast that may be used by tabletop role-playing game developers to grant permission to modify, copy, and redistribute some of the content designed for their games, notably game mechanics. However, they must share-alike copies and derivative works. [More information about the OGL can be found here.](https://en.wikipedia.org/wiki/Open_Game_License)  ### A monster, spell, subclass, etc. is missing from the API / Database. Can I add it? Please check if the data is within the SRD. If it is, feel free to open an issue or PR to add it yourself. Otherwise, due to legal reasons, we cannot add it.  ### Can this API be self hosted? Yes it can! You can also host the data yourself if you don't want to use the API at all. You can also make changes and add extra data if you like. However, it is up to you to merge in new changes to the data and API.  #### Can I publish is on <insert platform>? Is this free use? Yes, you can. The API itself is under the [MIT license](https://opensource.org/licenses/MIT), and the underlying data accessible via the API is supported under the SRD and OGL.  # Status Page  The status page for the API can be found here: https://5e-bits.github.io/dnd-uptime/  # Chat  Come hang out with us [on Discord](https://discord.gg/TQuYTv7)!  # Contribute  This API is built from two repositories.   - The repo containing the data lives here: https://github.com/bagelbits/5e-database   - The repo with the API implementation lives here: https://github.com/bagelbits/5e-srd-api  This is a evolving API and having fresh ideas are always welcome! You can open an issue in either repo, open a PR for changes, or just discuss with other users in this discord.   # noqa: E501

    OpenAPI spec version: 0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six
from dnd5apy.models.api_reference import APIReference  # noqa: F401,E501

class Weapon(APIReference):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'desc': 'list[str]',
        'equipment_category': 'APIReference',
        'weapon_category': 'str',
        'weapon_range': 'str',
        'category_range': 'str',
        'range': 'WeaponRange',
        'damage': 'Damage',
        'two_handed_damage': 'Damage',
        'properties': 'list[APIReference]',
        'cost': 'Cost',
        'weight': 'float'
    }
    if hasattr(APIReference, "swagger_types"):
        swagger_types.update(APIReference.swagger_types)

    attribute_map = {
        'desc': 'desc',
        'equipment_category': 'equipment_category',
        'weapon_category': 'weapon_category',
        'weapon_range': 'weapon_range',
        'category_range': 'category_range',
        'range': 'range',
        'damage': 'damage',
        'two_handed_damage': 'two_handed_damage',
        'properties': 'properties',
        'cost': 'cost',
        'weight': 'weight'
    }
    if hasattr(APIReference, "attribute_map"):
        attribute_map.update(APIReference.attribute_map)

    def __init__(self, desc=None, equipment_category=None, weapon_category=None, weapon_range=None, category_range=None, range=None, damage=None, two_handed_damage=None, properties=None, cost=None, weight=None, *args, **kwargs):  # noqa: E501
        """Weapon - a model defined in Swagger"""  # noqa: E501
        self._desc = None
        self._equipment_category = None
        self._weapon_category = None
        self._weapon_range = None
        self._category_range = None
        self._range = None
        self._damage = None
        self._two_handed_damage = None
        self._properties = None
        self._cost = None
        self._weight = None
        self.discriminator = None
        if desc is not None:
            self.desc = desc
        if equipment_category is not None:
            self.equipment_category = equipment_category
        if weapon_category is not None:
            self.weapon_category = weapon_category
        if weapon_range is not None:
            self.weapon_range = weapon_range
        if category_range is not None:
            self.category_range = category_range
        if range is not None:
            self.range = range
        if damage is not None:
            self.damage = damage
        if two_handed_damage is not None:
            self.two_handed_damage = two_handed_damage
        if properties is not None:
            self.properties = properties
        if cost is not None:
            self.cost = cost
        if weight is not None:
            self.weight = weight
        APIReference.__init__(self, *args, **kwargs)

    @property
    def desc(self):
        """Gets the desc of this Weapon.  # noqa: E501

        Description of the resource.  # noqa: E501

        :return: The desc of this Weapon.  # noqa: E501
        :rtype: list[str]
        """
        return self._desc

    @desc.setter
    def desc(self, desc):
        """Sets the desc of this Weapon.

        Description of the resource.  # noqa: E501

        :param desc: The desc of this Weapon.  # noqa: E501
        :type: list[str]
        """

        self._desc = desc

    @property
    def equipment_category(self):
        """Gets the equipment_category of this Weapon.  # noqa: E501


        :return: The equipment_category of this Weapon.  # noqa: E501
        :rtype: APIReference
        """
        return self._equipment_category

    @equipment_category.setter
    def equipment_category(self, equipment_category):
        """Sets the equipment_category of this Weapon.


        :param equipment_category: The equipment_category of this Weapon.  # noqa: E501
        :type: APIReference
        """

        self._equipment_category = equipment_category

    @property
    def weapon_category(self):
        """Gets the weapon_category of this Weapon.  # noqa: E501

        The category of weapon this falls into.  # noqa: E501

        :return: The weapon_category of this Weapon.  # noqa: E501
        :rtype: str
        """
        return self._weapon_category

    @weapon_category.setter
    def weapon_category(self, weapon_category):
        """Sets the weapon_category of this Weapon.

        The category of weapon this falls into.  # noqa: E501

        :param weapon_category: The weapon_category of this Weapon.  # noqa: E501
        :type: str
        """

        self._weapon_category = weapon_category

    @property
    def weapon_range(self):
        """Gets the weapon_range of this Weapon.  # noqa: E501

        Whether this is a Melee or Ranged weapon.  # noqa: E501

        :return: The weapon_range of this Weapon.  # noqa: E501
        :rtype: str
        """
        return self._weapon_range

    @weapon_range.setter
    def weapon_range(self, weapon_range):
        """Sets the weapon_range of this Weapon.

        Whether this is a Melee or Ranged weapon.  # noqa: E501

        :param weapon_range: The weapon_range of this Weapon.  # noqa: E501
        :type: str
        """

        self._weapon_range = weapon_range

    @property
    def category_range(self):
        """Gets the category_range of this Weapon.  # noqa: E501

        A combination of weapon_category and weapon_range.  # noqa: E501

        :return: The category_range of this Weapon.  # noqa: E501
        :rtype: str
        """
        return self._category_range

    @category_range.setter
    def category_range(self, category_range):
        """Sets the category_range of this Weapon.

        A combination of weapon_category and weapon_range.  # noqa: E501

        :param category_range: The category_range of this Weapon.  # noqa: E501
        :type: str
        """

        self._category_range = category_range

    @property
    def range(self):
        """Gets the range of this Weapon.  # noqa: E501


        :return: The range of this Weapon.  # noqa: E501
        :rtype: WeaponRange
        """
        return self._range

    @range.setter
    def range(self, range):
        """Sets the range of this Weapon.


        :param range: The range of this Weapon.  # noqa: E501
        :type: WeaponRange
        """

        self._range = range

    @property
    def damage(self):
        """Gets the damage of this Weapon.  # noqa: E501


        :return: The damage of this Weapon.  # noqa: E501
        :rtype: Damage
        """
        return self._damage

    @damage.setter
    def damage(self, damage):
        """Sets the damage of this Weapon.


        :param damage: The damage of this Weapon.  # noqa: E501
        :type: Damage
        """

        self._damage = damage

    @property
    def two_handed_damage(self):
        """Gets the two_handed_damage of this Weapon.  # noqa: E501


        :return: The two_handed_damage of this Weapon.  # noqa: E501
        :rtype: Damage
        """
        return self._two_handed_damage

    @two_handed_damage.setter
    def two_handed_damage(self, two_handed_damage):
        """Sets the two_handed_damage of this Weapon.


        :param two_handed_damage: The two_handed_damage of this Weapon.  # noqa: E501
        :type: Damage
        """

        self._two_handed_damage = two_handed_damage

    @property
    def properties(self):
        """Gets the properties of this Weapon.  # noqa: E501

        A list of the properties this weapon has.  # noqa: E501

        :return: The properties of this Weapon.  # noqa: E501
        :rtype: list[APIReference]
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this Weapon.

        A list of the properties this weapon has.  # noqa: E501

        :param properties: The properties of this Weapon.  # noqa: E501
        :type: list[APIReference]
        """

        self._properties = properties

    @property
    def cost(self):
        """Gets the cost of this Weapon.  # noqa: E501


        :return: The cost of this Weapon.  # noqa: E501
        :rtype: Cost
        """
        return self._cost

    @cost.setter
    def cost(self, cost):
        """Sets the cost of this Weapon.


        :param cost: The cost of this Weapon.  # noqa: E501
        :type: Cost
        """

        self._cost = cost

    @property
    def weight(self):
        """Gets the weight of this Weapon.  # noqa: E501

        How much the equipment weighs.  # noqa: E501

        :return: The weight of this Weapon.  # noqa: E501
        :rtype: float
        """
        return self._weight

    @weight.setter
    def weight(self, weight):
        """Sets the weight of this Weapon.

        How much the equipment weighs.  # noqa: E501

        :param weight: The weight of this Weapon.  # noqa: E501
        :type: float
        """

        self._weight = weight

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Weapon, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Weapon):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
